#include <ADCTouch.h>

/*
An open-source binary clock for Arduino. 
*/

int second=0, minute=0, hour=0, day=1, month=1;//start the time on 00:00:00
int munit=0;
int hunit=0;
int dayunit=0;
int monthunit=0;
int valm=0;
int valh=0;
int ledstats=0;
int i= 0;
boolean light=1;
int mode=1;
int timerduration=15;
int ptimerduration=15;
int captrigger=25; //set according to your own test
boolean timer=0;
int modeButton=0;
boolean alarmring=0;
boolean timerring=0;
unsigned long previousMillis=0;
boolean alarm=0;
int ledState=0;
int alarmhour=0;
int alarmminute=0;
unsigned long palarmMillis=0;
int buzState=0;
unsigned long alarmstart=0;
unsigned long timerstart=0;
unsigned long timerringstart=0;
unsigned long lastcorr=0; //used for time drift corrective
unsigned long corrdur=0; //how many millisecond it take to slow down one second (formula: corrdur=(2/(no. of second deviate/test duration))*1000) my corrdur is 86674

// global variables used in the serial function

char inputChar = 'X';
byte inputByte = 255;

const byte buffSize = 32;
char inputSeveral[buffSize]; // space for 31 chars and a terminator

byte maxChars = 12; // a shorter limit to make it easier to see what happens
                           //   if too many chars are entered

int inputInt = 0;
float inputFloat = 0.0;
char inputCsvString[12];


//===================

static unsigned long lastTick = 0; // set up a local variable to hold the last time we moved forward one second
// (static variables are initialized once and keep their values between function calls)
// move forward one second every 1000 milliseconds


void setup() { //set outputs and inputs
  pinMode(0, OUTPUT);
  pinMode(14, OUTPUT);pinMode(2, OUTPUT);pinMode(3, OUTPUT);pinMode(4, OUTPUT);pinMode(5, OUTPUT);
  pinMode(A4, OUTPUT);pinMode(7, OUTPUT);pinMode(8, OUTPUT);pinMode(9, OUTPUT);pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);pinMode(12, OUTPUT);pinMode(13, OUTPUT);pinMode(15, OUTPUT);pinMode(A2,OUTPUT);

  pinMode(A3, INPUT);
  Serial.begin(9600);
}


void loop() {
readCSV();
digitalWrite(0, HIGH);

if (millis() - lastTick >= 1000) {
  lastTick = millis();
  second++;
  if (mode == 1) {
    Blinkled(15,250);
  }
  Serial.print(hour);
  Serial.print(":");
  Serial.print(minute);
  Serial.print(":");
  Serial.println(second);

}

// move forward one minute every 60 seconds
  if (second >= 60) {
  minute++;
  second = 0; // reset seconds to zero
}

// move forward one hour every 60 minutes
if (minute >=60) {
  hour++;
  minute = 0; // reset minutes to zero
}

if (hour >=24) {
  hour=0; // reset hours to zero
  day++;
}

// move forward one month every 29/30/31 days
if (((month == 4) || (month == 6) || (month == 9) || (month == 11)) && (day >= 31)) {
  endofmonth();
}
else if (((month%2 == 0) || (month != 2)) && (month >= 7) && (day >=32)) {
  endofmonth();
}
else if ((month == 2) && (day >= 30)) {
  endofmonth();
}
else if ((month%2 != 2) && (month <= 7) && (day >= 32)) {
  endofmonth();
}

if (month >= 13) {
  month=1;
}

  munit = minute%10; //sets the variable munit and hunit for the unit digits (and day and month!)
  hunit = hour%10;
  dayunit = day%10;
  monthunit = month%10;

  modeButton=digitalRead(A3); //Read button state
  if ((modeButton == HIGH) && (alarmring == 0)) {
    mode++;
    delay(200);
  }
  else if ((modeButton == HIGH) && (alarmring ==1)) { //Button snooze feature
/*    alarmring=0;
    noTone(A2);
    alarmminute=minute+10; //snooze 10 minute
    if (alarmminute >= 60) {
      alarmhour++;
      alarmminute=0;
    }
    if (alarmhour >= 24) {
      alarmhour=0;
    }
    delay(150);*/
    alarmring=0;
    alarm=0;
    noTone(A2);
    delay(150);
  }
  if (mode >= 8) {
    mode=1;
  }

  if (mode == 1) { //mode 1: Display time
    if (alarm == 1) {
      Blinkled(15,500);
    }
    
    int caplevel=ADCTouch.read(A7);
    ptimerduration=timerduration;
    ledoff();
    ledcontrol(hour,hunit,minute,munit);
    if ((caplevel >= captrigger) && (alarmring == 0)) {
      if (alarm == 0) {
        alarm=1;
        delay(150);
      }
      else {
        alarm=0;
        delay(150);
      }
    }
    if ((caplevel >= captrigger) && (alarmring == 1)) {
/*     alarmring=0;
     alarm=0;
     Serial.print("Stopped: ");
     Serial.println(caplevel);
     noTone(A2);
     delay(150);*/
     alarmring=0;
     noTone(A2);
     alarmminute=minute+10; //snooze 10 minute
     if (alarmminute >= 60) {
       alarmhour++;
       alarmminute=0;
     }
     if (alarmhour >= 24) {
       alarmhour=0;
     }
     delay(150);
    }
  }

  else if (mode == 2) { //mode 2: Display date and month
    digitalWrite(A1,HIGH);
    ledcontrol(month,monthunit,day,dayunit);
  }

  else if (mode == 3) { //mode 3 : Set timer
    if (timer == 0) {
     digitalWrite(A1,HIGH);   
    }
    else if (timer == 1) {
      Blinkled(15,300);
    }
    int caplevel=ADCTouch.read(A7);
    Serial.println(ADCTouch.read(A7));
    ledcontrol(0,0,timerduration,timerduration%10);
    if (caplevel >= captrigger) {
      timer=1;
      timerduration++;
      timerstart=millis();
      if (timerduration >= 60) {
        timerduration=0;
        timer=0;
      }
      delay(150);
    }
  }

  else if (mode == 4) { //mode4: Set alarm hour
    if (alarm == 0) {
      digitalWrite(A1,HIGH);
    }
    else if (alarm == 1) {
      Blinkled(15,150);
    }
    int caplevel=ADCTouch.read(A7);
    ledcontrol(alarmhour,alarmhour%10,alarmminute,alarmminute%10);
    if (caplevel >= captrigger) {
      alarmhour++;
      if (alarmhour >= 24) {
        alarmhour=0;
      }
      delay(150);
    }
  }

  else if (mode == 5) { //mode5: Set alarm minute
    if (alarm == 0) {
      digitalWrite(A1,HIGH);
    }
    else if (alarm == 1) {
      Blinkled(15,150);
    }
    int caplevel=ADCTouch.read(A7);
    ledcontrol(alarmhour,alarmhour%10,alarmminute,alarmminute%10);
    if (caplevel >= captrigger) {
      alarmminute++;
      if (alarmminute >= 60) {
        alarmminute=0;
      }
      delay(150);
    }
  }
  
  else if (mode == 6) { //Time reset
    ledcontrol(0,7,20,0);
    int caplevel=ADCTouch.read(A7);
    if (caplevel >= captrigger) {
      minute=30;
      second=0;
      lastTick=millis();
      lastcorr=millis();
      ledcontrol(hour,hour%10,minute,minute%10);
      delay(150);
    }
  }

  else if (mode == 7) { //the "do nothing" mode
    ledcontrol(0,0,0,0);
    digitalWrite(A1,LOW);    
  }

//Alarm
  if (alarm==1) {
    if ((alarmhour==hour) && (alarmminute == minute) && (alarmring == 0)) { //When time equal to alarm time
      alarmring=1; //Ring the alarm!
      alarmstart=millis(); //set the time where alarm start to ring
    }
  }

  if (alarmring == 1) {
    //beep function
    alarmRing(250);
    if ((millis()-alarmstart) >= 600000) {
      noTone(A2); //snooze after 10 minute
      alarmring=0;
      alarmminute=alarmminute+20;
      if (alarmminute >= 60) {
        alarmhour++;
        alarmminute=0;
      }
      if (alarmhour >= 24) {
        alarmhour=0;
      }
    }
  }

//Timer
  if (timer == 1) { //if timer is on
     if (((millis()-timerstart) >= (timerduration*61440)) && (timerring ==0)) { //check if the duration reached
      timerring=1; //if so start ringing
      timerringstart=millis(); //and set when it start ringing
     }
  }

  if (timerring == 1) { //if started ringing
    alarmRing(250); //ring!
    if ((millis()-timerringstart) >= 2500) { //if ringed 5 times
      noTone(A2);
      timerring=0; //no more ringing
      timer=0; //no more timer
    }
  }

//Corrective mechanism
  //time drift corrective
  if (((millis()-lastcorr) >= corrdur) && (corrdur != 0)) {
   second++;
   lastcorr=millis();
   Serial.println("corrected");
  }
}

void endofmonth() {
  day=0; //reset days to zero
  month++;
}

void ledcontrol(int first,int funit,int last,int lunit) {
  //last unit
  if(lunit == 1 || lunit == 3 || lunit == 5 || lunit == 7 || lunit == 9) {  digitalWrite(2, LOW);} else {  digitalWrite(2, HIGH);}
  if(lunit == 2 || lunit == 3 || lunit == 6 || lunit == 7) {digitalWrite(3, LOW);} else {digitalWrite(3,HIGH);}
  if(lunit == 4 || lunit == 5 || lunit == 6 || lunit == 7) {digitalWrite(4, LOW);} else {digitalWrite(4,HIGH);}
  if(lunit == 8 || lunit == 9) {digitalWrite(5, LOW);} else {digitalWrite(5,HIGH);}

  //last
  //if((last >= 10 && last < 20) || (last >= 30 && last < 40) || (last >= 50 && last < 60))  {digitalWrite(A4, LOW);} else {digitalWrite(A4,HIGH);}
  if((last >= 10 && last < 20) || (last >= 30 && last < 40) || (last >= 50 && last < 60))  {digitalWrite(6, LOW);} else {digitalWrite(6,HIGH);}
  if(last >= 20 && last < 40)  {digitalWrite(7, LOW);} else {digitalWrite(7,HIGH);}
  if(last >= 40 && last < 60) {digitalWrite(8, LOW);} else {digitalWrite(8,HIGH);}

  //first units
  if(funit == 1 || funit == 3 || funit == 5 || funit == 7 || funit == 9) {digitalWrite(9, LOW);} else {digitalWrite(9,HIGH);}
  if(funit == 2 || funit == 3 || funit == 6 || funit == 7) {digitalWrite(10, LOW);} else {digitalWrite(10,HIGH);}
  if(funit == 4 || funit == 5 || funit == 6 || funit == 7) {digitalWrite(11, LOW);} else {digitalWrite(11,HIGH);}
  if(funit == 8 || funit == 9) {digitalWrite(12, LOW);} else {digitalWrite(12,HIGH);}

  //first
  if(first >= 10 && first < 20)  {digitalWrite(13, LOW);} else {digitalWrite(13,HIGH);}
  if(first >= 20 && first < 24)  {digitalWrite(A0, LOW);} else {digitalWrite(A0,HIGH);}
}

void ledoff() {
  for(i=1;i<=13;i++) {
    digitalWrite(i, HIGH);
  }
}

void Blinkled(int ledPin,int interval) {
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= interval) {
    // save the last time you blinked the LED
    previousMillis = currentMillis;

    // if the LED is off turn it on and vice-versa:
    if (ledState == LOW) {
      ledState = HIGH;
    } else {
      ledState = LOW;
    }

    // set the LED with the ledState of the variable:
    digitalWrite(ledPin, ledState);
  }
}

void alarmRing(int interval) { //modified from blinkled lol
  unsigned long alarmMillis = millis();

  if (alarmMillis - palarmMillis >= interval) {
    palarmMillis = alarmMillis;

    if (buzState == 0) {
      buzState = 1;
      tone(A2,3420);
    } else {
      buzState = 0;
      noTone(A2);
    }
  }
}

void readCSV() { //Another copy pasted code lol (with modification of course)

      // this function expects a series of comma separated values
      // for this demo the sequence of items must be a string, an integer, a float
      // for example testing, 123 , 4567.89
      // spaces around the commas are optional
   
        // first read severalChars into the array inputSeveral

    inputSeveral[0] = 0;
    maxChars = buffSize - 1; // use full size of buffer for this function
    byte charCount = 0;  
    byte ndx = 0;        
    
    if (Serial.available() > 0) {
      while (Serial.available() > 0) { 
        if (ndx > maxChars - 1) {
          ndx = maxChars;
        } 
        inputSeveral[ndx] = Serial.read();
        ndx ++;        
        charCount ++;
      }
      if (ndx > maxChars) { 
        ndx = maxChars;
      }
      inputSeveral[ndx] = 0; 
    }

      // now we need to split the received string into its parts
      // this is done by strtok() which looks for the token - the comma in this case

    char * partOfString; // this is used by strtok() as an index
    
    partOfString = strtok(inputSeveral,",");      // get the first part - the string
    strcpy(inputCsvString, partOfString); // copy it to inputCsvString
    
    partOfString = strtok(NULL, ","); // this continues where the previous call left off
    inputInt = atoi(partOfString);     // convert this part to an integer
    
    partOfString = strtok(NULL, ","); 
    inputFloat = atof(partOfString);     // convert this part to a float
    

//    Serial.print("String -- ");
//    Serial.print(inputCsvString);
//    Serial.print("  Int -- ");
//    Serial.println(inputInt);

    if (String(inputCsvString)==String("s")) {
      second=inputInt;
      lastcorr=millis(); //reset last correction time
      lastTick=millis();
      Serial.print("Second: ");
      Serial.println(second);
    }
    else if (String(inputCsvString)==String("min")) {
      minute=inputInt;
      Serial.print("Minute: ");
      Serial.println(minute);
    }
    else if (String(inputCsvString)==String("h")) {
      hour=inputInt;
      Serial.print("Hour: ");
      Serial.println(hour);
    }
    else if (String(inputCsvString)==String("d")) {
      day=inputInt;
      Serial.print("Day: ");
      Serial.println(day);
    }
    else if (String(inputCsvString)==String("mon")) {
      month=inputInt;
      Serial.print("Month: ");
      Serial.println(month);
    }
/*    else if (String(inputCsvString)==String("corrdur")) { //cant send large value via serial
      corrdur=inputInt;
      Serial.print("Correction interval: ");
      Serial.println(corrdur);
    }*/
}

//===================
